<h1 align="center">bedboss</h1>

<div align="center">
  
[![PEP compatible](https://pepkit.github.io/img/PEP-compatible-green.svg)](https://pep.databio.org/)

[//]: # (![Run pytests]&#40;https://github.com/bedbase/bedboss/workflows/Run%20instalation%20test/badge.svg&#41;)
[![pypi-badge](https://img.shields.io/pypi/v/bedboss?color=%2334D058)](https://pypi.org/project/bedboss)
[![pypi-version](https://img.shields.io/pypi/pyversions/bedboss.svg?color=%2334D058)](https://pypi.org/project/bedboss)
[![Code style: black](https://img.shields.io/badge/code%20style-black-000000.svg)](https://github.com/psf/black)
[![Github badge](https://img.shields.io/badge/source-github-354a75?logo=github)](https://github.com/databio/bedboss)

</div>

---

**Documentation**: <a href="https://docs.bedbase.org/bedboss" target="_blank">https://docs.bedbase.org/bedboss</a>

**Source Code**: <a href="https://github.com/databio/bedboss" target="_blank">https://github.com/databio/bedboss</a>

---

BEDboss is a command-line management tool for BEDbase. It contains pipelines that filters, standardizes, and calculates statistics for genomic interval data, 
functions that enters the results into a BEDbase database, deletes bed and bedsets from the database, and indexes the data to qdrant.

## Installation
To install `bedboss` use this command: 
```
pip install bedboss
```
or install the latest version from the GitHub repository:
```
pip install git+https://github.com/databio/bedboss.git
```

## Development
For development, you should install all the dependencies, create a virtual environment, and work on the local database.
The workflow is described in the [development documentation](https://docs.bedbase.org/bedboss/development).


## Testing

### Requirements test:

To test requirements, install bedboss and run: 

```
bedboss requirements-check
```

### Smoke tests:

Use this docs:
- [./test/README.md](./test/README.md)


## How to generate usage documentation:

Run this command in the root of the repository:
```
cd scripts
bash update_usage_docs.sh
```

# Reference Genome Predictor and Validator

-----

## Research Project Outline

#### Question

Can we give a BED file as an input and then determine a level of compatibility for different reference genome assemblies?


#### High Level Execution 

1. Ingest query bed file (without any annotations or metadata, for now).

2. Compare regions with chromosome lengths and chrom names.

   - Assumption: if regions exist beyond defined ref genome chromosomes,the bed file is less likely to be associated with the ref genome.
   - Use size files to get chrom lengths and names
   - How many chrom names in BED file that are _not_ in the size file?
   
3. Compare regions in bed files with excluded ranges/black list regions for each of reference genome.
   - Two Tiers: 
     1. Gaps/Centromeres/Telomeres (can be used to assign tiers for compatibility)
     2. All other Excluded Ranges (informational only)

4. Once the above are quantified, we can give probability of compatibility with reference genomes.


#### Detailed Execution Steps

1. Retrieve chrom size files for ref genome assemblies (can use seq collections API: https://refget.databio.org/).
2. Cache relevant BED files which contain excluded ranges using [BBClient](https://docs.bedbase.org/geniml/tutorials/bbclient/)
3. Build database for each refgenome assembly excluded ranges, gaps centromeres telomeres using [IGD](https://github.com/databio/gtars/tree/dev_igd) (Use rust implementation if finished, else use C++ implementation).
4. Query "unknown" BED File against chrom size files and the IGDs (using `igd search`).
5. Obtain overlap stats for each of the IGDs
6. Run on BED files whose ref genomes are _known_ and calculate accuracy of highest probability compatible ref genome.


#### Additional Notes
- Begin with human bed files and reference genomes for now.
- Compatibility assessed via:
  - different/levels of tiers based on cutoffs wrt specificity and sensitivity
  - These tiers are based on a variety of parameters of increasing complexity:
    - name matching of chromosomes
    - size overlaps (chr.sizes)
    - overlaps with centromeres/telomeres
    - ML (BED embeddings)
    - Bed annotations (text similarity)
- Future work could involve machine learning for ref genome prediction. However, we will begin with a simple classifier (which may be sufficient).
- Future work could add annotations/metadata for making the prediction.

#### Software Notes

- Create a validator class that can ingest a BED file as well as a GenomeModel object

## HERE I AM sourcing the helper functions
# Get the script's directory when running with Rscript
args <- commandArgs(trailingOnly = FALSE)
script_path <- sub("--file=", "", args[grep("--file=", args)]) # Extract script path
script_dir <- dirname(normalizePath(script_path))              # Get directory

# Source the helper functions
source(file.path(script_dir, "regionstat.R"))

runAnalysis = function(arguments) {
    message("R message => Running analysis with arguments: ", arguments)

    items <- strsplit(arguments, ", ")[[1]]

    bedPath <- items[1]
    digest <- items[2]
    outfolder <- items[3]
    genome <- items[4]
    openSignalMatrix <- items[5]
    gtffile <- items[6]

    if (!file.exists(bedPath)) {
		message("R message => File not found: ", path)
		setStatus("idle")
		return(1)
	}

    runBEDStats(bedPath, digest, outfolder, genome, openSignalMatrix, gtffile)

    return(0)
}

setStatus = function(status) {
	# message("R message => Setting status to ", status)
	assign("STATUS", status, .GlobalEnv)
}

# This function should run the process
processBED = function(path, client, port) {
	# message("R message => Signal received: ", path)

	if (path == "check") { # Status check signal
		# message("R message => Sending status to client: ", STATUS)
		# message("R message => socket client:", client)
		svSocket::send_socket_clients(STATUS, sockets=client)
		return(0)
	}

	if (path == "done") {  # Secret shutdown signal
		message("R message => Received done signal")
		assign("done", TRUE, envir=.GlobalEnv)
		return(0)
	}

	setStatus("processing")

    tryCatch({
        runAnalysis(path)
    }, error = function(e) {
        message("R message => Error: ", conditionMessage(e))
    }, finally = {
        # message("R message => Finished processing")
    })

	setStatus("idle")
	return(1)
}

message("R message => Starting R server")
STATUS = ""
svSocket::start_socket_server(procfun=processBED)
setStatus("idle")
message ("R message => R server started")

while (!exists("done")) Sys.sleep(1)

setStatus("finished")

message("R message => Shutting down R service")

args <- commandArgs(trailingOnly = FALSE)
script_path <- sub("--file=", "", args[grep("--file=", args)]) # Extract script path
script_dir <- dirname(normalizePath(script_path))
source(file.path(script_dir, "regionstat.R"))

library(optparse)
option_list = list(
  make_option(c("--bedfilePath"), type="character", default=NULL,
              help="full path to a BED file to process", metavar="character"),
  make_option(c("--openSignalMatrix"), type="character",
              help="path to the open signal matrix required for the tissue specificity plot", metavar="character"),
  make_option(c("--digest"), type="character", default=NULL,
              help="digest of the BED file", metavar="character"),
  make_option(c("--outputFolder"), type="character", default="output",
              help="base output folder for results", metavar="character"),
  make_option(c("--genome"), type="character", default="hg38",
              help="genome reference to calculate against", metavar="character"),
  make_option(c("--ensdb"), type="character",
              help="path to the Ensembl annotation gtf file", metavar="character")
)

opt_parser = OptionParser(option_list=option_list);
opt = parse_args(opt_parser);

if (is.null(opt$bedfilePath)) {
  print_help(opt_parser)
  stop("Bed file input missing.")
}

if (is.null(opt$digest)) {
  print_help(opt_parser)
  stop("digest input missing.")
}

if (is.null(opt$digest)) {
  print_help(opt_parser)
  stop("digest input missing.")
}

runBEDStats(opt$bedfilePath, opt$digest, opt$outputFolder, opt$genome, opt$openSignalMatrix, opt$ensdb)

# R Script that generates statistics for a bedfile

library(GenomicDistributions)
# library(GenomicDistributionsData)
# library(GenomeInfoDb)
# library(ensembldb)

library(tools)
library(R.utils)
library(rjson)

trim <- IRanges::trim

myPartitionList <- function(gtffile){
  features = c("gene", "exon", "three_prime_utr", "five_prime_utr")
  geneModels = getGeneModelsFromGTF(gtffile, features, TRUE)
  partitionList = genomePartitionList(geneModels$gene,
                                      geneModels$exon,
                                      geneModels$three_prime_utr,
                                      geneModels$five_prime_utr)

  return (partitionList)
}


myChromSizes <- function(genome){
  if (requireNamespace(BSgm, quietly=TRUE)){
    library (BSgm, character.only = TRUE)
    BSG = eval(as.name(BSgm))
  } else {
    library (BSg, character.only = TRUE)
    BSG = eval(as.name(BSg))
  }
  chromSizesGenome = seqlengths(BSG)
  return(chromSizesGenome)
}

plotBoth <- function(plotId, g, digest, outfolder){
  pth = paste0(outfolder, "/", digest, "_", plotId)
  print(paste0("Plotting: ", pth))
  ggplot2::ggsave(paste0(pth, ".png"), g, device="png", width=8, height=8, units="in")
  ggplot2::ggsave(paste0(pth, ".pdf"), g, device="pdf", width=8, height=8, units="in")
}

getPlotReportDF <- function(plotId, title, digest, outfolder){
  pth = paste0(outfolder, "/", digest, "_", plotId)
  rel_pth = getRelativePath(pth, paste0(outfolder, "/../../../"))
  print(paste0("Writing plot json: ", rel_pth))
  newPlot = data.frame(
    "name"=plotId,
    "title"=title,
    "thumbnail_path"=paste0(rel_pth, ".png"),
    "path"=paste0(rel_pth, ".pdf")
  )
  return(newPlot)
}


doItAll <- function(query, digest, genome, openSignalMatrix, outfolder, BSg, BSgm, gtffile) {
  plots = data.frame(stringsAsFactors=F)
  bsGenomeAvail = ifelse((requireNamespace(BSg, quietly=TRUE) | requireNamespace(BSgm, quietly=TRUE)), TRUE, FALSE)

  # check if json file exist for the input bed file
  meta_path = paste0(outfolder, "/", digest, ".json")
  plot_path = paste0(outfolder, "/", digest, "_plots.json")
  if (file.exists(meta_path)){
    bedmeta = fromJSON(file=meta_path)
    plots = fromJSON(file=plot_path)
    plots = as.data.frame(do.call(rbind, plots))
  } else{
    plots = data.frame(stringsAsFactors=F)
  }

  run_plot = TRUE
  # TSS distance plot
  if (exists("bedmeta")){
    if ("median_TSS_dist" %in% names(bedmeta)){
      run_plot = FALSE
    } else {
      run_plot = TRUE
    }
  } else {
    run_plot = TRUE
  }
  query_new = GenomeInfoDb::keepStandardChromosomes(query, pruning.mode="coarse")
  if (run_plot){
    tryCatch(
      expr = {
        if (!(genome %in% c("hg19", "hg38", "mm10", "mm9")) && gtffile == "None"){
          message("Ensembl annotation gtf file not provided. Skipping TSS distance plot ... ")
        } else{
          if (genome %in% c("hg19", "hg38", "mm10", "mm9")) {
            TSSdist = calcFeatureDistRefTSS(query_new, genome)
            plotBoth("tss_distance", plotFeatureDist( TSSdist, featureName="TSS"), digest, outfolder)
          } else {
            tss = getTssFromGTF(gtffile, TRUE)
            TSSdist = calcFeatureDist(query_new, tss)
            plotBoth("tss_distance", plotFeatureDist( TSSdist, featureName="TSS"), digest, outfolder)
          }
          plots = rbind(plots, getPlotReportDF("tss_distance", "Region-TSS distance distribution", digest, outfolder))
          message("Successfully calculated and plot TSS distance.")
        }
        if (exists("bedmeta")){
          tss <- list(median_TSS_dist = signif(median(abs(TSSdist), na.rm=TRUE), digits = 4))
          bedmeta = append(bedmeta, tss)
        }

      },
      error = function(e){
        message('Caught an error in creating: TSS distance plot!')
        print(e)
      }
    )
  }

  # Chromosomes region distribution plot
  if (!exists("bedmeta") ){
    tryCatch(
      expr = {
        if (genome %in% c("mm39", "dm3", "dm6", "ce10", "ce11", "danRer10", "danRer10", "T2T")){
          chromSizes = myChromSizes(genome)
          genomeBins  = getGenomeBins(chromSizes)
          plotBoth("chrombins", plotChromBins(calcChromBins(query, genomeBins)), digest, outfolder)
        } else{
          plotBoth("chrombins", plotChromBins(calcChromBinsRef(query_new, genome)), digest, outfolder)
        }

        plots = rbind(plots, getPlotReportDF("chrombins", "Regions distribution over chromosomes", digest, outfolder))
        message("Successfully calculated and plot chromosomes region distribution.")
      },
      error = function(e){
        message('Caught an error in creating: Chromosomes region distribution plot!')
        print(e)
      }
    )
  }

# We are calculating this differently now
#   # OPTIONAL: Plot GC content only if proper BSgenome package is installed.
#   if (exists("bedmeta")){
#     if ("gc_content" %in% names(bedmeta)){
#       run_plot = FALSE
#     } else {
#       run_plot = TRUE
#     }
#   } else {
#       run_plot = TRUE
#   }
#
#   if (run_plot){
#     if (bsGenomeAvail) {
#       tryCatch(
#         expr = {
#           if (requireNamespace(BSgm, quietly=TRUE)){
#             library (BSgm, character.only = TRUE)
#             bsg = eval(as.name(BSgm))
#             gcvec = calcGCContent(query, bsg)
#           } else {
#             library (BSg, character.only = TRUE)
#             bsg = eval(as.name(BSg))
#             gcvec = calcGCContent(query, bsg)
#           }
#           plotBoth("gccontent", plotGCContent(gcvec))
#           if (exists("bedmeta")){
#             gc_content <- list(gc_content = signif(mean(gcvec), digits = 4))
#             bedmeta = append(bedmeta, gc_content)
#           }
#           plots = rbind(plots, getPlotReportDF("gccontent", "GC content"))
#           message("Successfully calculated and plot GC content.")
#         },
#         error = function(e){
#           message('Caught an error in creating: GC content plot!')
#           print(e, gcvec)
#         }
#       )
#     }
#   }


  # Partition plots, default to percentages
  if (exists("bedmeta")){
    if ("exon_frequency" %in% names(bedmeta)){
      run_plot = FALSE
    } else {
      run_plot = TRUE
    }
  } else {
      run_plot = TRUE
  }

  if (run_plot){
    tryCatch(
      expr = {
        if (!(genome %in% c("hg19", "hg38", "mm10")) && gtffile == "None"){
          message("Ensembl annotation gtf file not provided. Skipping partition plot ... ")
        } else {
          if (genome %in% c("hg19", "hg38", "mm10")) {
            gp = calcPartitionsRef(query, genome)
            plotBoth("partitions", plotPartitions(gp), digest, outfolder)
          } else {
            partitionList = myPartitionList(gtffile)
            gp = calcPartitions(query, partitionList)
            plotBoth("partitions", plotPartitions(gp), digest, outfolder)
          }
          plots = rbind(plots, getPlotReportDF("partitions", "Regions distribution over genomic partitions", digest, outfolder))
          # flatten the result returned by the function above
          partiotionNames = as.vector(gp[,"partition"])
          partitionsList = list()
          for(i in seq_along(partiotionNames)){
            partitionsList[[paste0(partiotionNames[i], "_frequency")]] =
              as.vector(gp[,"Freq"])[i]
            partitionsList[[paste0(partiotionNames[i], "_percentage")]] =
              as.vector(gp[,"Freq"])[i]/length(query)
          }
          if (exists("bedmeta")){
            bedmeta = append(bedmeta, partitionsList)
          }
          message("Successfully calculated and plot regions distribution over genomic partitions.")
        }
      },
      error = function(e){
        message('Caught an error in creating: Partition plot!')
        print(e)
      }
    )
  }


  # Expected partition plots
  if (!exists("bedmeta") ){
    tryCatch(
      expr = {
        if (!(genome %in% c("hg19", "hg38", "mm10")) && gtffile == "None"){
          message("Ensembl annotation gtf file not provided. Skipping expected partition plot ... ")
        } else{
          if (genome %in% c("hg19", "hg38", "mm10")) {
            plotBoth("expected_partitions", plotExpectedPartitions(calcExpectedPartitionsRef(query, genome)), digest, outfolder)
          } else {
            partitionList = myPartitionList(gtffile)
            chromSizes = myChromSizes(genome)
            genomeSize = sum(chromSizes)
            plotBoth("expected_partitions", plotExpectedPartitions(calcExpectedPartitions(query, partitionList, genomeSize)), digest, outfolder)
          }
          plots = rbind(plots, getPlotReportDF("expected_partitions", "Expected distribution over genomic partitions", digest, outfolder))
          message("Successfully calculated and plot expected distribution over genomic partitions.")
        }
      },
      error = function(e){
        message('Caught an error in creating: Expected partition plot!')
        print(e)
      }
    )
  }

  # Cumulative partition plots
  if (!exists("bedmeta") ){
    tryCatch(
      expr = {
        if (!(genome %in% c("hg19", "hg38", "mm10")) && gtffile == "None"){
          message("Ensembl annotation gtf file not provided. Skipping cumulative partition plot ... ")
        } else{
          if (genome %in% c("hg19", "hg38", "mm10")) {
            plotBoth("cumulative_partitions", plotCumulativePartitions(calcCumulativePartitionsRef(query, genome)), digest, outfolder)
          } else{
            partitionList = myPartitionList(gtffile)
            plotBoth("cumulative_partitions", plotCumulativePartitions(calcCumulativePartitions(query, partitionList)), digest, outfolder)
          }
          plots = rbind(plots, getPlotReportDF("cumulative_partitions", "Cumulative distribution over genomic partitions", digest, outfolder))
          message("Successfully calculated and plot cumulative distribution over genomic partitions.")
        }
      },
      error = function(e){
        message('Caught an error in creating: Cumulative partition plot!')
        print(e)
      }
    )
  }

  # QThis plot
  if (exists("bedmeta")){
    if ("mean_region_width" %in% names(bedmeta)){
      run_plot = FALSE
    } else {
      run_plot = TRUE
    }
  } else {
      run_plot = TRUE
  }

  if (run_plot){
    tryCatch(
      expr = {
        widths = calcWidth(query)
        plotBoth("widths_histogram", plotQTHist(widths), digest, outfolder)
        if (exists("bedmeta")){
          mean_region_width <- list(mean_region_width = signif(mean(widths), digits = 4))
          bedmeta = append(bedmeta, mean_region_width)
        }
        plots = rbind(plots, getPlotReportDF("widths_histogram", "Quantile-trimmed histogram of widths", digest, outfolder))
        message("Successfully calculated and plot quantile-trimmed histogram of widths.")
      },
      error = function(e){
        message('Caught an error in creating: Quantile-trimmed histogram of widths plot!')
        print(e, widths)
      }
    )
  }

  # Neighbor regions distance plots
  if (!exists("bedmeta") ){
    tryCatch(
      expr = {
        plotBoth("neighbor_distances", plotNeighborDist(calcNeighborDist(query)), digest, outfolder)
        plots = rbind(plots, getPlotReportDF("neighbor_distances", "Distance between neighbor regions", digest, outfolder))
        message("Successfully calculated and plot distance between neighbor regions.")
      },
      error = function(e){
        message('Caught an error in creating: Distance between neighbor regions plot!')
        print(e)
      }
    )
  }

  ## This part is heavy and if needed can be skipped
  # Tissue specificity plot if open signal matrix is provided
  if (!exists("bedmeta") ){
    if (openSignalMatrix == "None") {
      message("open signal matrix not provided. Skipping tissue specificity plot ... ")
    } else {
      tryCatch(
        expr = {
          plotBoth("open_chromatin", plotSummarySignal(calcSummarySignal(query, data.table::fread(openSignalMatrix))), digest, outfolder)
          plots = rbind(plots, getPlotReportDF("open_chromatin", "Cell specific enrichment for open chromatin", digest, outfolder))
          message("Successfully calculated and plot cell specific enrichment for open chromatin.")
        },
        error = function(e){
          message('Caught an error in creating: Cell specific enrichment for open chromatin plot!')
          print(e)
        }
      )
    }
  }


  # Note: names of the list elements MUST match what's defined in: https://github.com/databio/bbconf/blob/master/bbconf/schemas/bedfiles_schema.yaml
  if (exists("bedmeta")){
    write(jsonlite::toJSON(bedmeta, pretty=TRUE), meta_path)
    write(jsonlite::toJSON(plots, pretty=TRUE, auto_unbox = TRUE), plot_path)
  } else {
    bedmeta = list(
      name=digest,
      number_of_regions=length(query),
      mean_region_width=ifelse(exists('widths'), signif(mean(widths), digits = 4), NA),
      md5sum=digest
    )
    if (exists('gcvec') && !isEmpty(gcvec)){
      gc_content <- list(gc_content = signif(mean(gcvec), digits = 4))
      bedmeta = append(bedmeta, gc_content)
    }
    if (exists('TSSdist') && !all(is.na(TSSdist))){
      tss <- list(median_TSS_dist = signif(median(abs(TSSdist), na.rm=TRUE), digits = 4))
      bedmeta = append(bedmeta, tss)
    }
    if (exists('partitionsList')){
      write(jsonlite::toJSON(c(bedmeta, partitionsList), pretty=TRUE), meta_path)
    } else {
      write(jsonlite::toJSON(c(bedmeta), pretty=TRUE), meta_path)
    }

    if (exists('plots')){
      write(jsonlite::toJSON(plots, pretty=TRUE, auto_unbox = TRUE), plot_path)
    }
  }
  }

runBEDStats = function (bedPath, digest, outfolder, genome, openSignalMatrix, gtffile) {
  # define values and output folder for doitall()
  message("R message =>  Running regionstat for: ", bedPath)
    message("R message =>  digest: ", digest)
    message("R message =>  outfolder: ", outfolder)
    message("R message =>  genome: ", genome)
    message("R message => openSignalMatrix: ", openSignalMatrix)
    message("R message =>  gtffile: ", gtffile)


  # build BSgenome package ID to check whether it's installed
    if ( startsWith(genome, "T2T")){
      BSg = "BSgenome.Hsapiens.NCBI.T2T.CHM13v2.0"
    } else {
      if (startsWith(genome, "hg") | startsWith(genome, "grch")) {
        orgName = "Hsapiens"
      } else if (startsWith(genome, "mm") | startsWith(genome, "grcm")){
        orgName = "Mmusculus"
      } else if (startsWith(genome, "dm")){
        orgName = "Dmelanogaster"
      } else if (startsWith(genome, "ce")){
        orgName = "Celegans"
      } else if (startsWith(genome, "danRer")){
        orgName = "Drerio"
      }  else if (startsWith(genome, "TAIR")){
        orgName = "Athaliana"
      } else {
        orgName = "Undefined"
      }
      BSg = paste0("BSgenome.", orgName , ".UCSC.", genome)
    }

  BSgm = paste0(BSg, ".masked")

  query = LOLA::readBed(bedPath)
  doItAll(query, digest, genome, openSignalMatrix, outfolder, BSg, BSgm, gtffile)
}

library(optparse)
library(data.table)
library(GenomicRanges)
library(LOLA)
library(ggplot2)
library(conflicted)
library(R.utils)

option_list = list(
    make_option(c("--bedfilelist"), type="character", default=NULL, 
                help="path to a txt file with list of BED files to process", 
                metavar="character"),
    make_option(c("--outputfolder"), type="character", default="output",
                help="base output folder for results", metavar="character"),
    make_option(c("--json"), type="character", default="output",
                help="path to the target JSON file", metavar="character"),
    make_option(c("--id"), type="character", default=NULL,
                help="BED set human-readable ID to use for output files prefix", 
                metavar="character")
)
opt_parser = OptionParser(option_list=option_list)
opt = parse_args(opt_parser)

if (is.null(opt$bedfilelist)) {
    print_help(opt_parser)
    stop("bedfilelist input missing.")
}

if (is.null(opt$outputfolder)) {
    print_help(opt_parser)
    stop("outputfolder input missing.")
}

if (is.null(opt$id)) {
    print_help(opt_parser)
    stop("id input missing.")
}

if (is.null(opt$json)) {
    print_help(opt_parser)
    stop("json input missing.")
}

#' Generate a universe matrix
#' 
#' Generates a universe matrix based on a list of refgionsets
#'
#' @param queryList 
#'
#' @return matrix where rows are regions and cols are a binary indications 
#' whether a regionset includes the region
#' 
#' @export
.getUniverseMtx <- function(queryList) {
    message("creating universe...")
    universe = (Reduce(c, queryList))
    mtx = matrix(data=0, nrow=length(universe), ncol=length(queryList))
    message("finding overlaps...")
    hits = sapply(queryList, function(x) (findOverlaps(x, universe)))
    for(e in seq_along(hits)){
        mtx[hits[[e]]@to, e] = 1
    }
    mtx
}

#' Calculate region commonality in a regionset
#'
#' Calculates how many regionsets (bedfiles) overlap at least said percentage 
#' of regions included in the universe. The universe is considered a union of 
#' all regionsets (bedfiles) in the collection of 
#' regionsets (bedset, or set of bedfiles)
#'
#' @param queryList GRangesList object with regionsets to be considered
#'
#' @return data.table with two columns: Perc with percentages and Counts with 
#' number of regionsets having at least this percentage of overlaps with 
#' the universe
#' 
#' @export
calcRegionCommonality <- function(queryList){
    mtx = .getUniverseMtx(queryList)
    per = (colSums(mtx)/dim(mtx)[1])*100
    x = unique(c(0, per))
    a=c()
    for(i in seq_along(x)){
        a[i] = length(which(per >= x[i]))
    }
    df = data.table(Perc=x, Counts=a)
    df
}

#' Plot region commonality in a regionset
#'
#' @param percCounts data.table with two columns: Perc with percentages and Counts with 
#' number of regionsets having at least this percentage of overlaps with 
#' the universe
#'
#' @return ggplot object
#' 
#' @export
plotRegionCommonality <- function(percCounts) {
    g = ggplot(percCounts, aes(x=Perc, y=Counts)) + 
        geom_point() +
        theme_bw() +
        geom_line(linetype="dotted", linewidth=0.1) +
        theme(aspect.ratio=1) + 
        xlab("Percentage of regions in universe (BED set) covered") +
        ylab("Regionset (BED file) count") +
        ggtitle("Region commonality") +
        xlim(0, 100) +
        ylim(0, 100)
    return(g)
}

plotBoth <- function(plotId, g){
    pth = paste0(opt$outputfolder, "/", opt$id, "_", plotId)
    print(paste0("Plotting: ", pth))
    ggplot2::ggsave(paste0(pth, ".png"), g, device="png", width=8, height=8, units="in")
    ggplot2::ggsave(paste0(pth, ".pdf"), g, device="pdf", width=8, height=8, units="in")
}

getPlotReportDF <- function(plotId, title){
    pth = paste0(opt$outputfolder, "/", opt$id, "_", plotId)
    print(paste0("Writing: ", pth))
    rel_pth = getRelativePath(pth, paste0(opt$outputfolder, ""))
    print(paste0("Writing: ", rel_pth))
    newPlot = data.frame(
        "name"=plotId, 
        "title"=title, 
        "thumbnail_path"=paste0(rel_pth, ".png"), 
        "path"=paste0(rel_pth, ".pdf"),
        stringsAsFactors = FALSE
    )
    return(newPlot)
}

doItAll <- function(opt) {
    bedlist = read.table(file=opt$bedfilelist, stringsAsFactors=FALSE)
    grl = GRangesList()
    for(i in seq_len(NROW(bedlist))){
        bed_path = paste0(bedlist[i, 1])
        if(!file.exists(bed_path)) stop("File not found: ", bed_path)
        message("reading BED: ", bed_path)
        grl[[i]] = LOLA::readBed(bed_path)
    }
    plotBoth("region_commonality", plotRegionCommonality(calcRegionCommonality(grl)))
    print(paste0("done plotting "))
    plots = getPlotReportDF("region_commonality", "BED region commonality in BED set")
    # Note: names of the list elements MUST match what's defined in: https://github.com/databio/bbconf/blob/master/bbconf/schemas/bedsets_schema.yaml
    write(jsonlite::toJSON(list(plots=plots), pretty=TRUE), opt$json)
    message("Saved JSON: ", opt$json)
}

bedlist = opt$bedfilelist
doItAll(opt=opt)

check_required_packages <- function() {
  # ANSI escape codes for colors
  red <- "\033[31m"
  green <- "\033[32m"
  reset <- "\033[0m"

  # List of required R packages
  required_packages <- c(
    "optparse", "devtools", "ensembldb", "ExperimentHub", "AnnotationHub",
    "AnnotationFilter", "BSgenome", "GenomicFeatures", "GenomicDistributions",
    "GenomicDistributionsData", "GenomeInfoDb", "tools", "R.utils", "LOLA", "conflicted"
  )

  # Check if each package is installed
  missing_packages <- required_packages[!sapply(required_packages, requireNamespace, quietly = TRUE)]

  # Get the installed packages
  installed_packages <- required_packages[sapply(required_packages, requireNamespace, quietly = TRUE)]

  # If there are missing packages, print them
  if (length(missing_packages) > 0) {
    cat(paste0(red, "The following packages are missing:\n", reset))
    cat(paste0(red, missing_packages, collapse = "\n"), "\n", reset)  # Print missing packages vertically
  } else {
    cat(paste0(green, "All R required packages are installed.\n", reset))
  }

  # Print installed packages vertically
  cat(paste0(green, "\nThe following packages are installed:\n", reset))
  cat(paste0(green, installed_packages, collapse = "\n"), "\n", reset)  # Print installed packages vertically

  # Return missing packages
  return(missing_packages)
}

# Call the function
missing_packages <- check_required_packages()

# Optionally handle missing packages
if (length(missing_packages) > 0) {
  quit(status = 1)
}
quit(status = 0)

.install_pkg = function(p, bioc=FALSE) {
    if(!require(package = p, character.only=TRUE)) {
        if(bioc) {
            BiocManager::install(pkgs = p)
        } else {
            install.packages(pkgs = p)   
        }
    }
}

.install_pkg("R.utils")
.install_pkg("BiocManager")
.install_pkg("optparse")
.install_pkg("devtools")
install.packages("https://cran.r-project.org/src/contrib/Archive/rjson/rjson_0.2.20.tar.gz", repos = NULL, type = "source")
.install_pkg("GenomicRanges", bioc=TRUE)
.install_pkg("GenomicFeatures", bioc=TRUE)
.install_pkg("ensembldb", bioc=TRUE)
.install_pkg("LOLA", bioc=TRUE)
.install_pkg("BSgenome", bioc=TRUE)
.install_pkg("ExperimentHub", bioc=TRUE)
.install_pkg("AnnotationHub", bioc=TRUE)
.install_pkg("conflicted")
.install_pkg("svSocket")
if(!require(package = "GenomicDistributions", character.only=TRUE)) {
    devtools::install_github("databio/GenomicDistributions", ref="dev_kinga")
}
options(timeout=2000)
if(!require(package = "GenomicDistributionsData", character.only=TRUE)) {
    install.packages("http://big.databio.org/GenomicDistributionsData/GenomicDistributionsData_0.0.2.tar.gz", repos=NULL)
}

# Estimates the number of lines in a file

file=$1
nsample=1000
headbytes=`head -q -n $nsample $file | wc -c`
#tailbytes=`tail -q -n $nsample $file | wc -c`
#echo $headbytes

filesize=`ls -sH --block-size=1 $file | cut -f1 -d" "`
#echo $filesize

echo -n $((filesize / (headbytes) * $nsample))
#echo " (" $((filesize / headbytes )) "K;" $((filesize / headbytes /1000 )) "M )"

#!/usr/bin/env bash
#
# bedboss pipeline dependencies installation check
#
echo -e "-----------------------------------------------------------"
echo -e "                                                           "
echo -e "             bedboss installation check                    "
echo -e "                                                           "
echo -e "-----------------------------------------------------------"

##############################################################
RED='\033[0;31m'
GREEN='\033[0;32m'
YELLOW='\033[0;33m'
NC='\033[0m' # No Color

fail() {
    printf "${RED}\u2716 $*${NC}\n"
}

success() {
    printf "${GREEN}\xE2\x9C\x94 $*${NC}\n"
}

warn() {
    printf "${YELLOW}\u26A0 $*${NC}\n"
}


# Helpful functions
trim() {
    local var="$*"
    # remove leading whitespace characters
    var="${var#"${var%%[![:space:]]*}"}"
    # remove trailing whitespace characters
    var="${var%"${var##*[![:space:]]}"}"
    printf '%s' "$var"
}

is_executable() {
    if [ -x "$(command -v $1)" ]; then
        echo $(success "$1 is installed correctly")
        return 0
    else
        echo $(warn "WARNING: '$1' is not installed. To install '$1' check bedboss documentation: https://docs.bedbase.org/")
        return 1
    fi
}

pip_check() {
    if pip show -q $1; then
        echo $(success "package $(pip freeze | grep $1)")
        return 0
    else
        echo $(fail "package $1 is not installed")
        return 1
    fi
}

r_check_req() {
cmd=$(echo "Rscript -e 'library(\"$1\")'")
    packageInstalled=$(eval $cmd 2>&1)
    if [[ "$packageInstalled" == *Error* ]]; then
        echo $(fail "Error: Please install the R package, $1, and checkinstall again.")
#       printf "\n"
        NATIVE_INSTALL=1
    else
        echo -e $(success "SUCCESS: R package: ${1}")
    fi
}

################################################################################
echo -e "Checking native installation...                            "
INSTALL_ERROR=0
INSTALL_WARNINGS=0

echo -e "Language compilers...                            "
echo -e "-----------------------------------------------------------"

# Check Python installation
if ! is_executable "python"; then
    if ! is_executable "python3"; then
      INSTALL_ERROR=$((INSTALL_ERROR+1))
    fi
fi
# is R installation
if ! is_executable "R"; then
    INSTALL_ERROR=$((INSTALL_ERROR+1))
fi
echo -e "-----------------------------------------------------------"
echo -e "Checking bedmaker dependencies...                            "
echo -e "-----------------------------------------------------------"

if ! pip_check "bedboss"; then
    INSTALL_ERROR=$((INSTALL_ERROR+1))
fi
if ! pip_check "refgenconf"; then
    INSTALL_ERROR=$((INSTALL_ERROR+1))
fi

## Check bedmaker packages (Moved to RegionSet in rust)
#if ! is_executable "bedToBigBed"; then
#    INSTALL_ERROR=$((INSTALL_ERROR+1))
#    echo $(fail "ERROR: 'bedToBigBed' is not installed. To install 'bedToBigBed' check bedboss documentation: https://bedboss.databio.org/")
#fi


if ! is_executable "bigBedToBed"; then
    INSTALL_WARNINGS=$((INSTALL_WARNINGS+1))
fi

if ! is_executable "bigWigToBedGraph"; then
    INSTALL_WARNINGS=$((INSTALL_WARNINGS+1))
fi

if ! is_executable "wigToBigWig"; then
    INSTALL_WARNINGS=$((INSTALL_WARNINGS+1))
fi

# Old requirements check
#if is_executable "R"; then
#
#    echo -e "-----------------------------------------------------------"
#    echo -e "Checking required R packages for bedstat...                            "
#    echo -e "-----------------------------------------------------------"
#    declare -a requiredRPackages=("optparse ""devtools" "ensembldb" "ExperimentHub" "AnnotationHub" "AnnotationFilter" "BSgenome" "GenomicFeatures" "GenomicDistributions" "GenomicDistributionsData" "GenomeInfoDb" "ensembldb" "tools" "R.utils" "LOLA" "conflicted")
#    for package in "${requiredRPackages[@]}"; do
#      if ! r_check_req $package; then
#        INSTALL_ERROR=$((INSTALL_ERROR+1))
#      fi
#done
#fi

if is_executable "Rscript"; then
    echo -e "-----------------------------------------------------------"
    echo -e "Checking required R packages for bedstat...                            "
    echo -e "-----------------------------------------------------------"

    SCRIPT_DIR=$(dirname "$(realpath "$0")")
#    echo "The script is located at: $SCRIPT_DIR"
    Rscript "$SCRIPT_DIR/check_R_req.R"

    if [ $? -eq 0 ]; then
      echo "All required packages are installed."
    else
       echo $(fail "ERROR: Some R required packages are missing. Please install them.")
      INSTALL_ERROR=$((INSTALL_ERROR+1))
    fi

fi

echo "Number of WARNINGS: $INSTALL_WARNINGS"

exit $INSTALL_ERROR
